
Ruby - Bug #7471

character class has duplicated range warning for "" =~ /[\w\W]/

11/30/2012 08:06 AM - drbrain (Eric Hodel)

Status: Closed   

Priority: Normal   

Assignee: naruse (Yui NARUSE)   

Target version: 2.0.0   

ruby -v: - Backport:  

Description

=begin

The warning seems bogus, \w and \W do not overlap.

$ cat test.rb

$-w = true

""=~/[\w\W]/

$ make runruby

/Users/drbrain/Work/svn/ruby/trunk/test.rb:3: warning: character class has duplicated range: /[\w\W]/

There is no warning with 1.9.3:

$ ~/.multiruby/install/1.9.3-p194/bin/ruby -v test.rb

ruby 1.9.3p194 (2012-04-20 revision 35410) [x86_64-darwin12.1.0]

[no output]

This affects abbrev.rb:

/usr/local/lib/ruby/2.0.0/abbrev.rb:77: warning: character class has duplicated range: /[\w\W]\z/

=end

Associated revisions

Revision 3c4633a3a1ace272566618c9e002489d3c03b569 - 11/30/2012 04:01 AM - Akinori MUSHA 

Stop using a regexp that causes a false warning.

lib/abbrev.rb (Abbrev#abbrev): Stop using a regexp that causes a

false warning. [Bug #7471]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@38028 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 3c4633a3 - 11/30/2012 04:01 AM - Akinori MUSHA 

Stop using a regexp that causes a false warning.

lib/abbrev.rb (Abbrev#abbrev): Stop using a regexp that causes a

false warning. [Bug #7471]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@38028 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision b44ac42335a9c135cd67a9881341fbf74b4b13fe - 01/13/2013 09:51 PM - naruse (Yui NARUSE)

regparse.c (add_ctype_to_cc): don't check dup warn on adding

negative ctype to cclass. [Bug #7471] [ruby-core:50344]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@38805 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision b44ac423 - 01/13/2013 09:51 PM - naruse (Yui NARUSE)

regparse.c (add_ctype_to_cc): don't check dup warn on adding

negative ctype to cclass. [Bug #7471] [ruby-core:50344]
git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@38805 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 11/30/2012 12:13 PM - knu (Akinori MUSHA)

- Assignee changed from usa (Usaku NAKAMURA) to knu (Akinori MUSHA)

#2 - 11/30/2012 01:01 PM - knu (Akinori MUSHA)

- Status changed from Open to Closed

- % Done changed from 0 to 100

This issue was solved with changeset r38028.

Eric, thank you for reporting this issue.

Your contribution to Ruby is greatly appreciated.

May Ruby be with you.

Stop using a regexp that causes a false warning.

lib/abbrev.rb (Abbrev#abbrev): Stop using a regexp that causes a

false warning. [Bug #7471]

#3 - 11/30/2012 01:02 PM - knu (Akinori MUSHA)

- Status changed from Closed to Open

- Assignee changed from knu (Akinori MUSHA) to naruse (Yui NARUSE)

While I worked around this, the warning itself looks like a bug in our regexp engine (Onigmo?).

#4 - 12/14/2012 04:49 PM - knu (Akinori MUSHA)

Onigmo doesn't have the code for detecting duplication in character class, so this problem seems to be on our own.

I narrowed the problem down:

% ruby@2.0.0 -EUS-ASCII -W2 -e '/[\D]/=~""'

-e:1: warning: character class has duplicated range: /[\D]/

% ruby@2.0.0 -EUS-ASCII -W2 -e '/[\W]/=~""'

-e:1: warning: character class has duplicated range: /[\W]/

Looks like CTYPE + NOT = FAIL.

#5 - 12/21/2012 10:22 PM - usa (Usaku NAKAMURA)

- Status changed from Open to Assigned

#6 - 01/14/2013 06:51 AM - naruse (Yui NARUSE)

- Status changed from Assigned to Closed

This issue was solved with changeset r38805.

Eric, thank you for reporting this issue.

Your contribution to Ruby is greatly appreciated.

May Ruby be with you.

regparse.c (add_ctype_to_cc): don't check dup warn on adding

negative ctype to cclass. [Bug #7471] [ruby-core:50344]
